import pygame, math
from math import sin, cos, pi
from pygame.locals import *

# Constantes
LARGEUR = 800
HAUTEUR = 600

VMAX = 20
VINC = 0.05
AINC = pi/24

def main():
	# Initialisation
	pygame.init()
	
	fenetre = pygame.display.set_mode((LARGEUR,HAUTEUR))
	horloge = pygame.time.Clock()
	
	c_fond = pygame.Color(0,0,64)
	i_vaisseau = pygame.image.load("vaisseau.png")
	
	x,y = 0,0
	vx,vy = 0,0
	a = pi/2
	
	# Boucle de jeu
	while (True):
		# Évènements clavier
		pygame.event.pump()
		clavier = pygame.key.get_pressed()
		if clavier[K_ESCAPE]:
			return 0
		# Rotation
		if clavier[K_RIGHT]:
			a -= AINC
		if clavier[K_LEFT]:
			a += AINC
		# Accélération
		if clavier[K_DOWN]:
			vx -= VINC*cos(a)
			vy -= VINC*sin(a)
		if clavier[K_UP]:
			vx += VINC*cos(a)
			vy += VINC*sin(a)
		
		# Déplacement
		x += vx
		y -= vy
		
		# Sortie de l'écran (boucle)
		x = x%LARGEUR
		y = y%HAUTEUR
		
		# Dessin (fond, vaisseau, écran)
		fenetre.fill(c_fond)

		i_joueur = pygame.transform.rotate(i_vaisseau, math.degrees(a-pi/2))
		jl, jh = i_joueur.get_size()
		fenetre.blit(i_joueur, (x-jl/2,y-jh/2,jl,jh))
		
		pygame.display.update()

		# Taux de rafraîchissement (60 IPS)
		horloge.tick(60)

main()
